// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.29.0
// source: sites.sql

package db

import (
	"context"
)

const createSite = `-- name: CreateSite :one
INSERT INTO sites (user_id, domain)
VALUES (?, ?)
RETURNING id, user_id, domain, created_at, updated_at
`

type CreateSiteParams struct {
	UserID int64  `json:"user_id"`
	Domain string `json:"domain"`
}

func (q *Queries) CreateSite(ctx context.Context, arg CreateSiteParams) (Site, error) {
	row := q.db.QueryRowContext(ctx, createSite, arg.UserID, arg.Domain)
	var i Site
	err := row.Scan(
		&i.ID,
		&i.UserID,
		&i.Domain,
		&i.CreatedAt,
		&i.UpdatedAt,
	)
	return i, err
}

const deleteSite = `-- name: DeleteSite :exec
DELETE FROM sites
WHERE id = ?
`

func (q *Queries) DeleteSite(ctx context.Context, id int64) error {
	_, err := q.db.ExecContext(ctx, deleteSite, id)
	return err
}

const getSiteByDomain = `-- name: GetSiteByDomain :one
SELECT id, user_id, domain, created_at, updated_at FROM sites
WHERE domain = ?
`

func (q *Queries) GetSiteByDomain(ctx context.Context, domain string) (Site, error) {
	row := q.db.QueryRowContext(ctx, getSiteByDomain, domain)
	var i Site
	err := row.Scan(
		&i.ID,
		&i.UserID,
		&i.Domain,
		&i.CreatedAt,
		&i.UpdatedAt,
	)
	return i, err
}

const getSiteByID = `-- name: GetSiteByID :one
SELECT id, user_id, domain, created_at, updated_at FROM sites
WHERE id = ?
`

func (q *Queries) GetSiteByID(ctx context.Context, id int64) (Site, error) {
	row := q.db.QueryRowContext(ctx, getSiteByID, id)
	var i Site
	err := row.Scan(
		&i.ID,
		&i.UserID,
		&i.Domain,
		&i.CreatedAt,
		&i.UpdatedAt,
	)
	return i, err
}

const getSitesByUserID = `-- name: GetSitesByUserID :many
SELECT id, user_id, domain, created_at, updated_at FROM sites
WHERE user_id = ?
ORDER BY created_at DESC
`

func (q *Queries) GetSitesByUserID(ctx context.Context, userID int64) ([]Site, error) {
	rows, err := q.db.QueryContext(ctx, getSitesByUserID, userID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []Site{}
	for rows.Next() {
		var i Site
		if err := rows.Scan(
			&i.ID,
			&i.UserID,
			&i.Domain,
			&i.CreatedAt,
			&i.UpdatedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
